package obtencionCodigos

import (
	"context"
	"daemonService/internal/notifications"
	"database/sql"
	"net/http"
	"time"
)

// interface
type CuisService interface {
	ExecuteGetCode(ctx context.Context, w http.ResponseWriter, req *http.Request, isCron bool) (interface{}, error)
	GetName() string
}

// configuración y dependencias para cada servicio
type CuisServiceModel struct {
	Name               string
	Enabled            bool
	Concurrency        int
	DB                 *sql.DB
	SOAPEndpoint       string
	SOAPTimeout        time.Duration
	SOAPRetries        int
	NotificationSender notifications.NotificationSender
	//APIKey             string
	TokenKey          string
	TokenValue        string
	TagNames          string
	TagNamesCufd      string
	QueryInsert       string
	MsgCustomResponse string
}
