package obtencionCodigos

import "time"

// mapea toda la tabla registroEmpresa
type RegistroEmpresa struct {
	ID                        int       `sql:"id"`
	CodigoAmbiente            int       `sql:"codigo_ambiente"`
	CodigoModalidad           int       `sql:"codigo_modalidad"`
	CodigoPuntoVenta          int       `sql:"codigo_punto_venta"`
	CodigoSistema             string    `sql:"codigo_sistema"`
	CodigoSucursal            int       `sql:"codigo_sucursal"`
	Nit                       string    `sql:"nit"`
	FechaCreacion             time.Time `sql:"fecha_creacion"`
	FechaActualizacion        time.Time `sql:"fecha_actualizacion"`
	TokenKey                  string    `sql:"token_key"`
	TokenValue                string    `sql:"token_value"`
	NombreArchivoCertificado  string    `sql:"nombre_archivo_certificado"`
	NombreArchivoClavePrivada string    `sql:"nombre_archivo_clave_privada"`
}

// solo tiene los dos campos que quieres de la tabla cuis
type CuisMinimal struct {
	Cuis_id       int64     `sql:"id"`
	Cuis          string    `sql:"cuis"`
	FechaVigencia time.Time `sql:"fecha_vigencia"`
}

// agrupa una empresa con sus cuis mínimos
type EmpresaConCuis struct {
	RegistroEmpresa
	Cuis []CuisMinimal
}

//import (
//"time"
//)
//
//// RegistroEmpresa mapea toda la tabla registroEmpresa
//type RegistroEmpresa struct {
//	ID                 int       `sql:"id"`
//	CodigoAmbiente     int       `sql:"codigo_ambiente"`
//	CodigoModalidad    int       `sql:"codigo_modalidad"`
//	CodigoPuntoVenta   int       `sql:"codigo_punto_venta"`
//	CodigoSistema      string    `sql:"codigo_sistema"`
//	CodigoSucursal     int       `sql:"codigo_sucursal"`
//	Nit                string    `sql:"nit"`
//	FechaCreacion      time.Time `sql:"fecha_creacion"`
//	FechaActualizacion time.Time `sql:"fecha_actualizacion"`
//}
//
//// CuisMinimal solo tiene los dos campos que quieres de la tabla cuis
//type CuisMinimal struct {
//	Cuis_id       int64     `sql:"id"`
//	Cuis          string    `sql:"cuis"`
//	FechaVigencia time.Time `sql:"fecha_vigencia"`
//}
//
//// EmpresaConCuis agrupa una empresa con sus cuis mínimos
//type EmpresaConCuis struct {
//	RegistroEmpresa
//	Cuis []CuisMinimal
//}
