package response

import "encoding/xml"

// Estructuras para respuesta SOAP
type SoapEnvelopeCuis struct {
	XMLName xml.Name     `xml:"Envelope"`
	Body    SoapBodyCuis `xml:"Body"`
}

type SoapBodyCuis struct {
	Response      *CuisResponse `xml:"cuisResponse,omitempty" json:"response,omitempty"`
	ResponseError *SoapFault    `xml:"Fault,omitempty"        json:"responseError,omitempty"`
}

type CuisResponse struct {
	Respuesta RespuestaCuis `xml:"RespuestaCuis"`
}

type RespuestaCuis struct {
	Codigo        string       `xml:"codigo,omitempty" json:"codigo,omitempty"`
	FechaVigencia string       `xml:"fechaVigencia,omitempty" json:"fechaVigencia,omitempty"`
	Transaccion   bool         `xml:"transaccion,omitempty" json:"transaccion,omitempty"`
	MensajesList  []MsgDetalle `xml:"mensajesList,omitempty" json:"mensajesList,omitempty"`
}

// CUSTOMER RESPONSE: parte del Body se envia al CustomerResponseModel.go
type MsgDetalle struct {
	Codigo      string `xml:"codigo,omitempty" json:"codigo,omitempty"`
	Mescripcion string `xml:"descripcion,omitempty" json:"descripcion,omitempty"`
}
