package response

import (
	"encoding/xml"
)

type SoapEnvelopeTipoHabitacion struct {
	XMLName xml.Name               `xml:"Envelope"`
	Body    SoapBodyTipoHabitacion `xml:"Body"`
}

type SoapBodyTipoHabitacion struct {
	Response SincronizarResponseTipoHabitacion `xml:"sincronizarParametricaTipoHabitacionResponse"`
}

type SincronizarResponseTipoHabitacion struct {
	RespuestaLista RespuestaListaParametricasTipoHabitacion `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasTipoHabitacion struct {
	Transaccion  bool             `xml:"transaccion"`
	ListaCodigos []TipoHabitacion `xml:"listaCodigos"`
}

type TipoHabitacion struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeTipoHabitacion) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeTipoHabitacion) GetData() []TipoHabitacion {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
