package response

import (
	"encoding/xml"
)

type SoapEnvelopeTipoDocumento struct {
	XMLName xml.Name              `xml:"Envelope"`
	Body    SoapBodyTipoDocumento `xml:"Body"`
}

type SoapBodyTipoDocumento struct {
	Response SincronizarResponseTipoDocumento `xml:"sincronizarParametricaTipoDocumentoIdentidadResponse"`
}

type SincronizarResponseTipoDocumento struct {
	RespuestaLista RespuestaListaParametricasTipoDocumento `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasTipoDocumento struct {
	Transaccion  bool            `xml:"transaccion"`
	ListaCodigos []TipoDocumento `xml:"listaCodigos"`
}

type TipoDocumento struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeTipoDocumento) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeTipoDocumento) GetData() []TipoDocumento {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
