package response

import (
	"encoding/xml"
)

type SoapEnvelopeTipoSector struct {
	XMLName xml.Name           `xml:"Envelope"`
	Body    SoapBodyTipoSector `xml:"Body"`
}

type SoapBodyTipoSector struct {
	Response SincronizarResponseTipoSector `xml:"sincronizarParametricaTipoDocumentoSectorResponse"`
}

type SincronizarResponseTipoSector struct {
	RespuestaLista RespuestaListaParametricasTipoSector `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasTipoSector struct {
	Transaccion  bool         `xml:"transaccion"`
	ListaCodigos []TipoSector `xml:"listaCodigos"`
}

type TipoSector struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeTipoSector) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeTipoSector) GetData() []TipoSector {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
