package response

import (
	"encoding/xml"
)

// Estructuras para la respuesta SOAP.
type SoapEnvelopeTipoEmision struct {
	XMLName xml.Name            `xml:"Envelope"`
	Body    SoapBodyTipoEmision `xml:"Body"`
}

type SoapBodyTipoEmision struct {
	Response SincronizarResponseTipoEmision `xml:"sincronizarParametricaTipoEmisionResponse"`
}

type SincronizarResponseTipoEmision struct {
	RespuestaLista RespuestaListaParametricasTipoEmision `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasTipoEmision struct {
	Transaccion  bool          `xml:"transaccion"`
	ListaCodigos []TipoEmision `xml:"listaCodigos"`
}

type TipoEmision struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeTipoEmision) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeTipoEmision) GetData() []TipoEmision {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
