package response

import (
	"encoding/xml"
)

// Estructuras para la respuesta SOAP.
type SoapEnvelopeTipoFactura struct {
	XMLName xml.Name            `xml:"Envelope"`
	Body    SoapBodyTipoFactura `xml:"Body"`
}

type SoapBodyTipoFactura struct {
	Response SincronizarResponseTipoFactura `xml:"sincronizarParametricaTiposFacturaResponse"`
}

type SincronizarResponseTipoFactura struct {
	RespuestaLista RespuestaListaParametricasTipoFactura `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasTipoFactura struct {
	Transaccion  bool          `xml:"transaccion"`
	ListaCodigos []TipoFactura `xml:"listaCodigos"`
}

type TipoFactura struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeTipoFactura) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeTipoFactura) GetData() []TipoFactura {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
