package response

import (
	"encoding/xml"
)

// Estructuras para la respuesta SOAP.
type SoapEnvelopeMetodoPago struct {
	XMLName xml.Name           `xml:"Envelope"`
	Body    SoapBodyMetodoPago `xml:"Body"`
}

type SoapBodyMetodoPago struct {
	Response SincronizarResponseMetodoPago `xml:"sincronizarParametricaTipoMetodoPagoResponse"`
}

type SincronizarResponseMetodoPago struct {
	RespuestaLista RespuestaListaParametricasMetodoPago `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasMetodoPago struct {
	Transaccion  bool         `xml:"transaccion"`
	ListaCodigos []MetodoPago `xml:"listaCodigos"`
}

type MetodoPago struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeMetodoPago) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeMetodoPago) GetData() []MetodoPago {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
