package response

import (
	"encoding/xml"
)

// Estructuras para la respuesta SOAP.
type SoapEnvelopeMoneda struct {
	XMLName xml.Name       `xml:"Envelope"`
	Body    SoapBodyMoneda `xml:"Body"`
}

type SoapBodyMoneda struct {
	Response SincronizarResponseMoneda `xml:"sincronizarParametricaTipoMonedaResponse"`
}

type SincronizarResponseMoneda struct {
	RespuestaLista RespuestaListaParametricasMoneda `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasMoneda struct {
	Transaccion  bool     `xml:"transaccion"`
	ListaCodigos []Moneda `xml:"listaCodigos"`
}

type Moneda struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeMoneda) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeMoneda) GetData() []Moneda {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
