package response

import (
	"encoding/xml"
)

type SoapEnvelopeMotivoAnulacion struct {
	XMLName xml.Name                `xml:"Envelope"`
	Body    SoapBodyMotivoAnulacion `xml:"Body"`
}

type SoapBodyMotivoAnulacion struct {
	Response SincronizarResponseMotivoAnulacion `xml:"sincronizarParametricaMotivoAnulacionResponse"`
}

type SincronizarResponseMotivoAnulacion struct {
	RespuestaLista RespuestaListaParametricasMotivoAnulacion `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasMotivoAnulacion struct {
	Transaccion  bool              `xml:"transaccion"`
	ListaCodigos []MotivoAnulacion `xml:"listaCodigos"`
}

type MotivoAnulacion struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeMotivoAnulacion) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeMotivoAnulacion) GetData() []MotivoAnulacion {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
