package response

import (
	"encoding/xml"
)

type SoapEnvelopeUnidadMedida struct {
	XMLName xml.Name             `xml:"Envelope"`
	Body    SoapBodyUnidadMedida `xml:"Body"`
}

type SoapBodyUnidadMedida struct {
	Response SincronizarResponseUnidadMedida `xml:"sincronizarParametricaUnidadMedidaResponse"`
}

type SincronizarResponseUnidadMedida struct {
	RespuestaLista RespuestaListaParametricasUnidadMedida `xml:"RespuestaListaParametricas"`
}

type RespuestaListaParametricasUnidadMedida struct {
	Transaccion  bool           `xml:"transaccion"`
	ListaCodigos []UnidadMedida `xml:"listaCodigos"`
}

type UnidadMedida struct {
	CodigoClasificador string `xml:"codigoClasificador" json:"codigo"`
	Descripcion        string `xml:"descripcion" json:"descripcion"`
}

// Implementaciones para cada tipo de envelope
func (e SoapEnvelopeUnidadMedida) IsTransactionSuccessful() bool {
	return e.Body.Response.RespuestaLista.Transaccion
}

func (e SoapEnvelopeUnidadMedida) GetData() []UnidadMedida {
	return e.Body.Response.RespuestaLista.ListaCodigos
}
